OBJ = \
	dmd/access.o \
	dmd/array.o \
	dmd/attrib.o \
	dmd/cast.o \
	dmd/class.o \
	dmd/cond.o \
	dmd/constfold.o \
	dmd/dchar.o \
	dmd/declaration.o \
	dmd/delegatize.o \
	dmd/doc.o \
	dmd/dsymbol.o \
	dmd/dump.o \
	dmd/entity.o \
	dmd/enum.o \
	dmd/expression.o \
	dmd/func.o \
	dmd/gnuc.o \
	dmd/hdrgen.o \
	dmd/html.o \
	dmd/id.o \
	dmd/identifier.o \
	dmd/import.o \
	dmd/inifile.o \
	dmd/init.o \
	dmd/inline.o \
	dmd/lexer.o \
	dmd/link.o \
	dmd/lstring.o \
	dmd/mangle.o \
	dmd/macro.o \
	dmd/mars.o \
	dmd/mem.o \
	dmd/module.o \
	dmd/mtype.o \
	dmd/opover.o \
	dmd/optimize.o \
	dmd/parse.o \
	dmd/root.o \
	dmd/scope.o \
	dmd/statement.o \
	dmd/staticassert.o \
	dmd/stringtable.o \
	dmd/struct.o \
	dmd/template.o \
	dmd/unialpha.o \
	dmd/utf.o \
	dmd/version.o \
	dmd/impcnvtab.o \
	stub.o

CXX = g++
CXXFLAGS +=  -Idmd
EXE = dmdfe
IDGEN = idgen
IMPCNV = impcnvgen

dynamic_files = dmd/$(IDGEN) dmd/$(IMPCNV) dmd/id.h dmd/id.c dmd/impcnvtab.c

targets : $(EXE)

# Make helper programs to generate conversion table and identifiers
dmd/$(IDGEN) : dmd/idgen.c
	cd dmd; $(CXX) $(CXXFLAGS) idgen.c -o $(IDGEN)

dmd/id.h : dmd/$(IDGEN)
	cd dmd; ./$(IDGEN)

dmd/id.c : dmd/$(IDGEN)
	cd dmd; ./$(IDGEN)

dmd/$(IMPCNV) : dmd/impcnvgen.c
	cd dmd; $(CXX) $(CXXFLAGS) impcnvgen.c -o $(IMPCNV)

dmd/impcnvtab.c : dmd/$(IMPCNV)
	cd dmd; ./$(IMPCNV)

# Default Rule
%.o : %.c dmd/id.h
	$(CXX) -c $(CXXFLAGS) -o$@ $<

# Build main executable
$(EXE) : $(OBJ)
	$(CXX) -o$@ $(OBJ)

# Clean obj files
clean :
	$(RM) $(OBJ) $(EXE) $(dynamic_files)
