/* DMDFE backend stubs
 * This file contains the implementations of the backend routines.
 * For dmdfe these do nothing but print a message saying the module
 * has been parsed. Substitute your own behaviors for these routimes.
 */

#include <stdio.h>

#include "total.h"
#include "init.h"
#include "template.h"
#include "mtype.h"

struct Symbol{
};

void Module::genobjfile(){
	printf("successfully parsed and analyzed module %s\n", toChars());
}

Symbol *Module::toModuleAssert(){
	return NULL;
}
Symbol *Module::toModuleArray(){
	return NULL;
}

void Module::genmoduleinfo(){
}

dt_t *ArrayInitializer::toDtBit(){
	return NULL;
}

void ClassDeclaration::toDt2(dt_t **pdt, ClassDeclaration *cd){
}

Symbol *ClassDeclaration::toVtblSymbol(){
	return NULL;
}

SymbolDeclaration::SymbolDeclaration(Loc loc, Symbol *s, StructDeclaration *dsym)
    : Declaration(new Identifier("", TOKidentifier)){
}

Symbol *SymbolDeclaration::toSymbol(){
	return sym;
}

Symbol *Dsymbol::toSymbolX(const char *prefix, int sclass, type *t){
	return NULL;
}

Symbol *Dsymbol::toImport(){
	return NULL;
}

Symbol *Dsymbol::toImport(Symbol *sym){
	return NULL;
}

Symbol *FuncDeclaration::toThunkSymbol(int offset){
	return NULL;
}

Symbol *AggregateDeclaration::toInitializer(){
	return NULL;
}

Symbol *TypeAArray::aaGetSymbol(char *func, int flags){
	return NULL;
}

AsmStatement::AsmStatement(Loc loc, Token *tokens) :
    Statement(loc){
}

Statement *AsmStatement::syntaxCopy(){
	return NULL;
}

Statement *AsmStatement::semantic(Scope *sc){
	return Statement::semantic(sc);
}

int AsmStatement::comeFrom(){
	return false;
}

int TypeBasic::builtinTypeInfo(){
	return true;
}

void obj_includelib(char*){
}

void backend_init(){
}

void backend_term(){
}

Symbol *static_sym(){
	return NULL;
}

Expression *Type::getInternalTypeInfo(Scope *sc){
	return NULL;
}

Expression *Type::getTypeInfo(Scope *sc){
	return NULL;
}

Expression *createTypeInfoArray(Scope *sc, Expression *args[], int dim){
	return NULL;
}

/*Expression * Expression::toDelegate(Scope* s, Type* t){
	return NULL;
}*/

unsigned ClassDeclaration::baseVtblOffset(BaseClass *bc){
	return 0;
}


#define STUB(x) int x::builtinTypeInfo() { return 0; }
STUB(Type);
STUB(TypeDArray);
#undef STUB

#define STUB(x) void x::toCBuffer(OutBuffer*, HdrGenState*) {}
STUB(AsmStatement);
STUB(Module);
#undef STUB

#define STUB(x) elem *x::toElem(IRState * p) { return NULL; }
STUB(AddAssignExp);
STUB(AddExp);
STUB(AddrExp);
STUB(AndAndExp);
STUB(AndAssignExp);
STUB(AndExp);
STUB(ArrayLengthExp);
STUB(ArrayLiteralExp);
STUB(AssertExp);
STUB(AssignExp);
STUB(BoolExp);
STUB(CallExp);
STUB(CastExp);
STUB(CatAssignExp);
STUB(CatExp);
STUB(CmpExp);
STUB(ComExp);
STUB(CommaExp);
STUB(ComplexExp);
STUB(CondExp);
STUB(DeclarationExp);
STUB(DelegateExp);
STUB(DeleteExp);
STUB(DivAssignExp);
STUB(DivExp);
STUB(DotTypeExp);
STUB(DotVarExp);
STUB(EqualExp);
STUB(Expression);
STUB(FuncExp);
STUB(HaltExp);
STUB(IdentityExp);
STUB(IndexExp);
STUB(InExp);
STUB(IntegerExp);
STUB(MinAssignExp);
STUB(MinExp);
STUB(ModAssignExp);
STUB(ModExp);
STUB(MulAssignExp);
STUB(MulExp);
STUB(NegExp);
STUB(NewExp);
STUB(NotExp);
STUB(NullExp);
STUB(OrAssignExp);
STUB(OrExp);
STUB(OrOrExp);
STUB(PostDecExp);
STUB(PostIncExp);
STUB(PtrExp);
STUB(RealExp);
STUB(RemoveExp);
STUB(ScopeExp);
STUB(ShlAssignExp);
STUB(ShlExp);
STUB(ShrAssignExp);
STUB(ShrExp);
STUB(SliceExp);
STUB(StringExp);
STUB(SymOffExp);
STUB(ThisExp);
STUB(TypeDotIdExp);
STUB(TypeExp);
STUB(UshrAssignExp);
STUB(UshrExp);
STUB(VarExp);
STUB(XorAssignExp);
STUB(XorExp);
#undef STUB

#define STUB(x) void x::toObjFile() {}
STUB(ClassDeclaration);
STUB(Dsymbol);
STUB(EnumDeclaration);
STUB(FuncDeclaration);
STUB(InterfaceDeclaration);
STUB(StructDeclaration);
STUB(TypedefDeclaration);
STUB(TypeInfoDeclaration);
STUB(VarDeclaration);
#undef STUB

#define STUB(x) void x::toDt(dt_t **pdt){}
STUB(ClassDeclaration);
STUB(StructDeclaration);
STUB(TypeInfoArrayDeclaration);
STUB(TypeInfoAssociativeArrayDeclaration);
STUB(TypeInfoClassDeclaration);
STUB(TypeInfoDeclaration);
STUB(TypeInfoDelegateDeclaration);
STUB(TypeInfoEnumDeclaration);
STUB(TypeInfoFunctionDeclaration);
STUB(TypeInfoInterfaceDeclaration);
STUB(TypeInfoPointerDeclaration);
STUB(TypeInfoStaticArrayDeclaration);
STUB(TypeInfoStructDeclaration);
STUB(TypeInfoTypedefDeclaration);
#undef STUB

#define STUB(x) dt_t *x::toDt() { return NULL; }
STUB(ArrayInitializer);
STUB(ExpInitializer);
STUB(Initializer);
STUB(StructInitializer);
STUB(VoidInitializer);
#undef STUB

#define STUB(x) dt_t **x::toDt(dt_t **pdt) { return NULL; }
STUB(ComplexExp);
STUB(Expression);
STUB(IntegerExp);
STUB(NullExp);
STUB(RealExp);
STUB(StringExp);
STUB(SymOffExp);
STUB(Type);
STUB(TypeSArray);
STUB(TypeStruct);
STUB(TypeTypedef);
STUB(VarExp);
#undef STUB

#define STUB(x) unsigned x::totym() { return 0; }
STUB(Type);
STUB(TypeFunction);
#undef STUB

#define STUB(x) type * x::toCParamtype() { return NULL; }
STUB(Type);
STUB(TypeSArray);
STUB(TypeTypedef);
#undef STUB

#define STUB(x) type * x::toCtype() { return NULL; }
STUB(Type);
STUB(TypeAArray);
STUB(TypeClass);
STUB(TypeDArray);
STUB(TypeDelegate);
STUB(TypeEnum);
STUB(TypeFunction);
STUB(TypePointer);
STUB(TypeSArray);
STUB(TypeStruct);
STUB(TypeTypedef);
#undef STUB

#define STUB(x) void x::toIR(IRState * p) {}
STUB(BreakStatement);
STUB(OnScopeStatement);
STUB(ForStatement);
STUB(WithStatement);
STUB(SynchronizedStatement);
STUB(ReturnStatement);
STUB(ContinueStatement);
STUB(DefaultStatement);
STUB(CaseStatement);
STUB(SwitchStatement);
STUB(SwitchErrorStatement);
STUB(Statement);
STUB(IfStatement);
STUB(ForeachStatement);
STUB(DoStatement);
STUB(WhileStatement);
STUB(ExpStatement);
STUB(CompoundStatement);
STUB(ScopeStatement);
STUB(AsmStatement);
STUB(TryCatchStatement);
STUB(TryFinallyStatement);
STUB(VolatileStatement);
STUB(LabelStatement);
STUB(ThrowStatement);
STUB(GotoCaseStatement);
STUB(GotoDefaultStatement);
STUB(GotoStatement);
#undef STUB

#define STUB(x) void x::toDebug() { }
STUB(ClassDeclaration);
STUB(EnumDeclaration);
STUB(StructDeclaration);
STUB(TypedefDeclaration);
#undef STUB

#define STUB(x) int x::cvMember(unsigned char* p) { return 0; }
STUB(Dsymbol);
STUB(EnumDeclaration);
STUB(FuncDeclaration);
STUB(TypedefDeclaration);
STUB(VarDeclaration);
#undef STUB

#define STUB(x) Symbol* x::toSymbol() { return NULL; }
STUB(ClassDeclaration);
STUB(ClassInfoDeclaration);
STUB(Dsymbol);
STUB(FuncDeclaration);
STUB(InterfaceDeclaration);
STUB(Module);
STUB(ModuleInfoDeclaration);
STUB(Type);
STUB(TypeClass);
STUB(TypeInfoDeclaration);
STUB(VarDeclaration);
#undef STUB

/*#define STUB(x) void x::scanForNestedRef(Scope *buf) { }
STUB(ArrayExp);
STUB(ArrayLiteralExp);
STUB(BinExp);
STUB(CallExp);
STUB(CondExp);
STUB(DeclarationExp);
STUB(Expression);
STUB(IndexExp);
STUB(NewExp);
STUB(SliceExp);
STUB(SuperExp);
STUB(SymOffExp);
STUB(ThisExp);
STUB(UnaExp);
STUB(VarExp);
#undef STUB*/

#define STUB(x) TypeInfoDeclaration *x::getTypeInfoDeclaration() { return NULL; }
STUB(Type);
STUB(TypeAArray);
STUB(TypeClass);
STUB(TypeDArray);
STUB(TypeDelegate);
STUB(TypeEnum);
STUB(TypeFunction);
STUB(TypePointer);
STUB(TypeSArray);
STUB(TypeStruct);
STUB(TypeTypedef);
#undef STUB
